/* *****************************************************************************
  HD4470n tW[pR[h     060429 041217 im
  Kusunoki Masahirô̂ꕔύX
  LCDread͍s킸delayŃ^C~OĂ̂  read֌W͍폜.
  n[hEGAGNDɐڑĂ
  050225  WinAVR20050214Ή̂   cbi  sbi  outp  inp  B
  060117  SRAMȂ\ lcd_putstrp() ǉB
  
  悭g֐
  //  lcd_init();
  //  lcd_cls();
  //  lcd_gotopos(uint8_t col,uint8_t lin);
  //  lcd_putch(uint8_t ch);
  //  lcd_putstr(uint8_t *str);
  //  lcd_putstrp("");

  ӁFCvO #include <avr/pgmspace.h> KvłB
    
******************************************************************************* */

#include <avr/pgmspace.h>
#include "lcd.h"

uint8_t columns;
uint8_t lines;

void lcd_delay(void) {
  volatile uint16_t i;
  for(i = 5000; i--; ) {  //4MHzł5000ok..16MHzł20000Kv  ł8MHz 5000œ
  }
}

void lcd_e(void) {
  LCD_CTL_PORT|=_BV(LCD_E);   
  LCD_CTL_PORT&=~_BV(LCD_E);  
}

void lcd_cls(void) {
  columns = lines = 0;
  lcd_putcmd(0x01);
}

void lcd_gotopos(uint8_t col,uint8_t lin) {
  switch(lin) {
  case 0: lcd_putcmd(0x80 + col); break;
  case 1: lcd_putcmd(0xC0 + col); break;
  }
  columns = col;
  lines = lin;
}

void lcd_setpos(void) {
  columns = 0;
  switch(++lines) {
  case 2: lines = 0; lcd_putcmd(0x80); break;
  case 1:            lcd_putcmd(0xC0); break;
  }
}

void lcd_cmdout_s(uint8_t cmd) {
  uint8_t wk;
  LCD_CTL_PORT&=~_BV(LCD_RS);   
  wk=LCD_DATA_PORT;             // o̓|[gǂł
  wk = wk & 0xF0;
  wk = wk + cmd;
  LCD_DATA_PORT=wk;             //
  lcd_e();
}

void lcd_putcmd(uint8_t cmd) {
  lcd_cmdout_s(cmd >> 4);
  lcd_cmdout_s(cmd & 0x0F);
  lcd_delay();
}

void lcd_dataout_s(uint8_t ch) {
  uint8_t wk;
  LCD_CTL_PORT|=_BV(LCD_RS);  
  wk=LCD_DATA_PORT;           
  wk = wk & 0xF0;
  wk = wk | ch;
  LCD_DATA_PORT=wk;           
  lcd_e();
}

void lcd_putch(uint8_t ch) {
  lcd_dataout_s(ch >> 4);
  lcd_dataout_s(ch & 0x0F);
  lcd_delay();
  if(++columns == LCD_COL) {
    lcd_setpos();
  }
}

void lcd_putstr(char* str) {
  while(*str) {
    lcd_putch(*str++);
  }
}

void lcd_init(void) {
	
  LCD_DATA_PORT_DDR|=_BV(LCD_D4)|_BV(LCD_D5)|_BV(LCD_D6)|_BV(LCD_D7);  //f[^bit  o͕
  LCD_CTL_PORT_DDR|=_BV(LCD_RS)|_BV(LCD_E);                            //Rg[bit o͕
	
  lcd_delay();
  lcd_delay();
  lcd_delay();
  lcd_delay();

  LCD_CTL_PORT&=~_BV(LCD_RS);   
  LCD_CTL_PORT&=~_BV(LCD_E);    

  lcd_cmdout_s(0x03); lcd_delay();
  lcd_cmdout_s(0x03); lcd_delay();
  lcd_cmdout_s(0x03); lcd_delay();
  lcd_cmdout_s(0x02); lcd_delay();
  lcd_putcmd(0x28);
  lcd_putcmd(0x08);
  lcd_putcmd(0x01);
  lcd_putcmd(0x0C);
  columns = 0;
  lines = 0;
}

//void lcd_putstr_P(const prog_char *s) 
void lcd_putstr_P(const char *s) 
{   // string on FLASH to LCD
    char c;
    while((c=pgm_read_byte(s++))!=0) lcd_putch(c);
}
